//*****************************************************************************
// Variable Declaration
//*****************************************************************************
var reg_pathname = "HKLM\\Software\\NEC\\ESMSM\\PathName";
var module_dir = "..\\module\\";
var title_msg = "NEC ESMPRO Manager Updater";
var start_msg = "Start the update process.";
var abort_msg = "Abort the update process.";
var error_msg = "An error occurred. Errcode:";
var complete_msg = "Update process is complete.";
var shell = WScript.CreateObject("WScript.Shell");
var fs = WScript.CreateObject("Scripting.FileSystemObject");

//*****************************************************************************
// Main
//*****************************************************************************
// Update Start
var btncode = shell.Popup(start_msg, 0, title_msg,1);
if (btncode != 1) {
	// Cancel
	shell.Popup(abort_msg, 0, title_msg);
	WScript.Quit(1);
}

// Get PathName from registry
try{
	var copypath =	shell.RegRead(reg_pathname ) + "\\bin";
}
catch(e){
	shell.Popup(error_msg + "101\n" + abort_msg, 0, title_msg);
	WScript.Quit(2);
}

// Check Path
if (!fs.FolderExists(copypath)) {
	shell.Popup(error_msg + "102\n" + abort_msg, 0, title_msg);
	WScript.Quit(3);
}

// Back Up
var ret = BackUp();
if( ret != 0 ){
	shell.Popup(error_msg + ret + "\n" + abort_msg, 0, title_msg);
	WScript.Quit(4);
}

// Update
ret = UpdateFile();
if( ret != 0 ){
	shell.Popup(error_msg + ret + "\n" + abort_msg, 0, title_msg);
	WScript.Quit(5);
}

// Delete Back up file
ret = DeleteBackUp();
if( ret != 0 ){
	shell.Popup(error_msg + ret + "\n" + abort_msg, 0, title_msg);
	WScript.Quit(6);
}


// Complete
shell.Popup(complete_msg, 0, title_msg);

// Main End 
WScript.Quit(0);

//*****************************************************************************
// Local Function : BackUp()
//*****************************************************************************
function BackUp() {
	try{
		fs.CopyFile(copypath + "\\ObjCtls.exe", copypath + "\\ObjCtls.bak");
	}
	catch (e) {
		return 201;
	}
	try{
		fs.CopyFile(copypath + "\\ObjCtli.exe", copypath + "\\ObjCtli.bak");
	}
	catch (e) {
		return 202;
	}
	try{
		fs.CopyFile(copypath + "\\ObjUhdg.exe", copypath + "\\ObjUhdg.bak");
	}
	catch (e) {
		return 203;
	}
	try{
		fs.CopyFile(copypath + "\\ObjUhde.exe", copypath + "\\ObjUhde.bak");
	}
	catch (e) {
		return 204;
	}
	try{
		fs.CopyFile(copypath + "\\ObjUhdl.exe", copypath + "\\ObjUhdl.bak");
	}
	catch (e) {
		return 205;
	}
	try{
		fs.CopyFile(copypath + "\\ObjUtpe.exe", copypath + "\\ObjUtpe.bak");
	}
	catch (e) {
		return 206;
	}
	try{
		fs.CopyFile(copypath + "\\ObjUsce.exe", copypath + "\\ObjUsce.bak");
	}
	catch (e) {
		return 207;
	}
	try{
		fs.CopyFile(copypath + "\\ObjUide.exe", copypath + "\\ObjUide.bak");
	}
	catch (e) {
		return 208;
	}
	try{
		fs.CopyFile(copypath + "\\Ob2Fsg.exe", copypath + "\\Ob2Fsg.bak");
	}
	catch (e) {
		return 209;
	}
	try{
		fs.CopyFile(copypath + "\\Ob2Fsnt.exe", copypath + "\\Ob2Fsnt.bak");
	}
	catch (e) {
		return 210;
	}
	try{
		fs.CopyFile(copypath + "\\Ob2MUdvg.exe", copypath + "\\Ob2MUdvg.bak");
	}
	catch (e) {
		return 211;
	}
	try{
		fs.CopyFile(copypath + "\\Ob2MUdve.exe", copypath + "\\Ob2MUdve.bak");
	}
	catch (e) {
		return 212;
	}
	return 0;
}

//*****************************************************************************
// Local Function:UpdateFile
//*****************************************************************************
function UpdateFile() {
	try{
		fs.CopyFile(module_dir + "ObjCtls.exe", copypath + "\\");
	}
	catch (e) {
		return 301;
	}
	try{
		fs.CopyFile(module_dir + "ObjCtli.exe", copypath + "\\");
	}
	catch (e) {
		return 302;
	}
	try{
		fs.CopyFile(module_dir + "ObjUhdg.exe", copypath + "\\");
	}
	catch (e) {
		return 303;
	}
	try{
		fs.CopyFile(module_dir + "ObjUhde.exe", copypath + "\\");
	}
	catch (e) {
		return 304;
	}
	try{
		fs.CopyFile(module_dir + "ObjUhdl.exe", copypath + "\\");
	}
	catch (e) {
		return 305;
	}
	try{
		fs.CopyFile(module_dir + "ObjUtpe.exe", copypath + "\\");
	}
	catch (e) {
		return 306;
	}
	try{
		fs.CopyFile(module_dir + "ObjUsce.exe", copypath + "\\");
	}
	catch (e) {
		return 307;
	}
	try{
		fs.CopyFile(module_dir + "ObjUide.exe", copypath + "\\");
	}
	catch (e) {
		return 308;
	}
	try{
		fs.CopyFile(module_dir + "Ob2Fsg.exe", copypath + "\\");
	}
	catch (e) {
		return 309;
	}
	try{
		fs.CopyFile(module_dir + "Ob2Fsnt.exe", copypath + "\\");
	}
	catch (e) {
		return 310;
	}
	try{
		fs.CopyFile(module_dir + "Ob2MUdvg.exe", copypath + "\\");
	}
	catch (e) {
		return 311;
	}
	try{
		fs.CopyFile(module_dir + "Ob2MUdve.exe", copypath + "\\");
	}
	catch (e) {
		return 312;
	}
	return 0;
}

//*****************************************************************************
// Local Function:DeleteBackUp
//*****************************************************************************
function DeleteBackUp() {
	try{
		fs.DeleteFile(copypath + "\\ObjCtls.bak");
	}
	catch (e) {
		return 401;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjCtli.bak");
	}
	catch (e) {
		return 402;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjUhdg.bak");
	}
	catch (e) {
		return 403;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjUhde.bak");
	}
	catch (e) {
		return 404;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjUhdl.bak");
	}
	catch (e) {
		return 405;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjUtpe.bak");
	}
	catch (e) {
		return 406;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjUsce.bak");
	}
	catch (e) {
		return 407;
	}
	try{
		fs.DeleteFile(copypath + "\\ObjUide.bak");
	}
	catch (e) {
		return 408;
	}
	try{
		fs.DeleteFile(copypath + "\\Ob2Fsg.bak");
	}
	catch (e) {
		return 409;
	}
	try{
		fs.DeleteFile(copypath + "\\Ob2Fsnt.bak");
	}
	catch (e) {
		return 410;
	}
	try{
		fs.DeleteFile(copypath + "\\Ob2MUdvg.bak");
	}
	catch (e) {
		return 411;
	}
	try{
		fs.DeleteFile(copypath + "\\Ob2MUdve.bak");
	}
	catch (e) {
		return 412;
	}
	return 0;
}